#include <ctime>
#include <cstdlib>
#include <queue>
#include <set>
#include <cmath>
#include <string.h>
#include <iostream>
#include "config.h"
using namespace std;

// my own data
extern char *PlayerName;
TEntity base;
int prizeWorker=0;
int prizeFighter=0;
struct bod {int x, y;
	bod(int xx=0,int yy=0):x(xx), y(yy) {}
} sur;
int vzd(bod a) {
	return abs(a.x-base.x)+abs(a.y-base.y);
}
int max(int a, int b) {return a>b?a:b;}
int maxvzd(bod a) { return max (abs(a.x-base.x), abs(a.y-base.y));}

struct PCukor {
	bod k; int poc;
	bool operator()(const PCukor & a, const PCukor & b) {
		return 2*vzd(a.k)/*-a.poc*/<2*vzd(b.k)/*-b.poc*/;
	}
};
struct zor {
	bool operator()(const PCukor& a, const PCukor& b) {
		if (a.k.x==b.k.x) return a.k.y<b.k.y;
		else return a.k.x<b.k.x;
	}
};
set<PCukor, PCukor> pc; set<PCukor, zor> strom;
typedef set<PCukor, PCukor>::iterator prst;
typedef set<PCukor, zor>::iterator trsp;
const int mpol=MAP_SIZE/2;

bool oktah2(int x, int y, int x2, int y2, const TMap & map) {
	if (ID_TYPE(map.field[x2][y2])!=etEmpty) return false;
	if (ID_SUGAR(map.field[x2][y2])&&ID_SUGAR(map.field[x][y])) return false;
	return true;
}
// born
//   called when the entity borns
//    ent          -- this entity (id, coordinates, ...)
//    nplayers     -- number of players in a game
//    map_w,map_h  -- coordinates, size of the map
int mapw, maph;
int born(TEntity ent, int nplayers, int map_w, int map_h, int pr_worker, int pr_fighter){
  srand(time(NULL)+ent.x*ent.y);
  base = ent; strcpy(PlayerName,"Nevypinat!");
  mapw=map_w; maph=map_h;

  //prizeWorker=pr_worker;
  //prizeFighter=pr_fighter;
  
  return dirStay;
}

// step_(base|fighter|worker)
//   make a single step of a given entity
//    ent          -- this entity (id, coordinates, ...)
//    map          -- part of map visible around entity (with other entities)
//
//    *out_msg     -- message to send
//    returns direction to move in
const int h[4][2]={{0,1},{1,0},{0,-1},{-1,0}};
int bfs(const TMap & map, int x, int y) {
	queue<bod> f;
	TMap m; memset(&m,0,sizeof(TMap));
	int x1, y1;
	if (sur.x==x) {
		x1=mpol; if (y<sur.y) y1=0;
		else y1=6;
	}
	else {
		if (sur.y==y) {
			y1=mpol; if (x<sur.x) x1=0;
			else x1=6;
		}
		else { 
			if (abs(sur.x-x)<abs(sur.y-y)) {x1=sur.x>x?6:0; y1=3-((3*(sur.y-y))/(sur.x-x)); }
			else {y1=sur.y>y?6:0; x1=3-((3*(sur.x-x))/(sur.y-y)); }
		}
	}
	f.push(bod(x1,y1));
	for (; !f.empty(); f.pop()) {
			bod b = f.front();
			for (int i=0; i<4; i++) {
					int xx=b.x-h[i][0], yy=b.y-h[i][1];
					if (xx>=0&&xx<MAP_SIZE&&yy>=0&&xx<MAP_SIZE)
							if (!m.field[xx][yy] && oktah2(b.x,b.y,xx,yy, map)) {
								m.field[xx][yy] = i;
								f.push(bod(xx, yy));
					}
			}
	}
	return m.field[3][3];
}
queue<bool> t;
int ptah=0; bod ciel; int mam_ciel=0;
int step_base(TEntity ent, TMap map, TEntityCount cnt, TMessage *out_msg)
{
  int pl=ID_PLAYER(ent.id); ptah++;
  int okolo=0, voj=0;
  for (int j=0; j<MAP_SIZE; j++) for (int i=0; i<MAP_SIZE; i++) {
  	okolo+=(ID_PLAYER(map.field[j][i])==pl);
	voj+=(ID_PLAYER(map.field[j][i])!=pl&&ID_TYPE(map.field[j][i])==etFighter);
  }
  int opt=(MAP_SIZE*MAP_SIZE)/5;//bola tu 7 asi v strede tyzdna
  if (voj>0) t.push(1); 
  if (/*cnt.workers*/okolo<opt && ent.sugar >= prizeWorker) t.push(0);
  if ((5*cnt.fighters<cnt.workers)&&ptah%3==0) t.push(1);
  if (!t.empty()) {
		  if (t.front()) {if (ent.sugar>=prizeFighter) {t.pop(); return bornFighter;}}
		  else if (ent.sugar>=prizeWorker) {t.pop(); return bornWorker;}
  }
  if (2*ent.sugar>3*prizeFighter&&cnt.fighters<50) return bornFighter; 
  return bornNone;
}


bool oktah(int x, int y, const TMap & map) {
	if (ID_TYPE(map.field[mpol+x][mpol+y])!=etEmpty) return false;
	if (ID_SUGAR(map.field[mpol+x][mpol+y])&&ID_SUGAR(map.field[mpol][mpol])) return false;
	return true;
}

int kam(bod a, const TMap & map) {
	//
	static bod last[2];
	static int opak;
	if (sur.x==last[1].x && sur.y==last[1].y) opak++;
	last[1]=last[0];
	last[0]=sur;
	//
	if (opak>4) {
   		prst kk=pc.begin(); 
		for (int e=random(pc.size()); kk!=pc.end()&&e>0; kk++, e--) ciel=kk->k;
		opak=0;
	}
	
	int dx=a.x-sur.x, dy=a.y-sur.y;
//	return bfs(map, a.x, a.y);
	int k=2*(dx>0)-1, l=2*(dy>0)-1;
	
	if (abs(dx)>abs(dy)) {
		if (oktah(k, 0, map)) {dx=k; dy=0;}
		else {
//			if (l==0) l=random(2)-1;		//added
			if (ID_TYPE(map.field[mpol+k][mpol])==etWorker) return k==1?(oktah(0,-1,map)?dirDown:dirUp):dirStay;
			if (oktah(0, l, map) ){dx=0; dy=l;}
			else return random(5);
		}
	} else {	
		if (oktah(0, l, map)) {dx=0; dy=l;}
		else {
//			if (k==0) k=random(2)-1;		//added
		if (ID_TYPE(map.field[mpol+k][mpol])==etWorker) return l==1?(oktah(1,0,map)?dirRight:dirLeft):dirStay;
			if (oktah(k, 0, map) ){dx=k; dy=0;}
			else return random(5);
		}
	}
	if ((dx<0) &&  (dy<0))  if (dx<dy) return dirDown; else return dirLeft;
	if ((dx<0) &&  (dy>=0)) if (-dx<dy) return dirUp; else return dirLeft;
	if ((dx>=0) && (dy<0))  if (dx<-dy) return dirDown; else return dirRight;
	if ((dx>=0) && (dy>=0)) if (dx<dy) return dirUp; else return dirRight;
}
int step_fighter(TEntity ent, TMap map, TMessage *out_msg) {
	sur.x=ent.x; sur.y=ent.y; int pl=ID_PLAYER(ent.id); ptah++;
	if (ciel.x==sur.x&&ciel.y==sur.y) mam_ciel=0;	
	if(mam_ciel==0||ptah%27==0) {
		int o=mapw/MAP_SIZE, p=maph/MAP_SIZE; mam_ciel=1;
		ciel.x=random(o+1)*MAP_SIZE+(mapw%MAP_SIZE)/2;
		ciel.y=random(p+1)*MAP_SIZE+(maph%MAP_SIZE)/2;
		if (random(7)==0) {
				ciel.x=base.x+random(11)-5;
				ciel.y=base.y+random(11)-5;
		}
	}
    int min=25, m1, m2;
	for (int j=0; j<MAP_SIZE; j++) for (int i=0; i<MAP_SIZE; i++)
		if (ID_PLAYER(map.field[j][i])!=pl&&(ID_TYPE(map.field[j][i])==etFighter||
		 ID_TYPE(map.field[j][i])==etWorker)) 
		 	if(abs(j-3)+abs(i-3)<min) {m1=j+sur.x-3; m2=i+sur.y-3; min=abs(j-3)+abs(i-3);}
	if (min<25) {
		mam_ciel=2; ciel.x=m1; ciel.y=m2;
	}
	return kam(ciel, map);
}
int step_worker(TEntity ent, TMap map, TMessage *out_msg)
{
  // test messages
  ptah++; sur.x=ent.x; sur.y=ent.y;
  if (ptah==1) for (int j=0; j<MAP_SIZE; j++) for (int i=0; i<MAP_SIZE; i++) 
     if ( (ID_TYPE(map.field[i][j]) == etBase)  && 
          (ID_PLAYER(map.field[i][j]) == ID_PLAYER(ent.id)) ) {
	 	base.y=sur.y+j-MAP_SIZE/2; base.x=sur.x+i-MAP_SIZE/2;
	 }
  for (int j=0; j<MAP_SIZE; j++) for (int i=0; i<MAP_SIZE; i++) {
       PCukor tmp; tmp.k.x=sur.x+i-mpol; tmp.k.y=sur.y+j-mpol; tmp.poc=ID_SUGAR(map.field[i][j]);
	   if (strom.find(tmp)!=strom.end()&&tmp.poc==0) {
  	       prst tu=strom.find(tmp); pc.erase(*tu);
		   strom.erase(tmp);
	   }
	   if (tmp.poc) {
	       if(strom.find(tmp)==strom.end()) {
		  	    pc.insert(pc.begin(), tmp);
				strom.insert(strom.begin(), tmp);
		   }
		   else {
		  		prst tm=strom.find(tmp); strom.erase(tmp);
				pc.erase(*tm);
				pc.insert(pc.begin(), tmp);
				strom.insert(strom.begin(), tmp);
		   }
	   }
  }
  bod zak; zak.x=base.x; zak.y=base.y;
  if (ent.sugar) { mam_ciel=0;  return kam(zak, map); }
  else if (sur.x==ciel.x&&sur.y==ciel.y) mam_ciel=0;
  if (!pc.empty()&&mam_ciel!=1) {
  	  if (maxvzd(sur)<3) {
		  int mrokolo;	// mravcov okolo mraveniska
	  	  for (int j=0; j<MAP_SIZE; j++) for (int i=0; i<MAP_SIZE; i++) {
	  	 	  mrokolo+=(ID_TYPE(map.field[i][j])!=etEmpty);
	  	  }
		  if (mrokolo>3) {
   			prst kk=pc.begin(); 
			for (int e=random(pc.size()/2); kk!=pc.end()&&e>0; kk++, e--) ciel=kk->k;
		  }
	  }

		  
   	  prst kk=pc.begin(); int yu=floor(sqrt(float(mapw*maph))/3)+2;
	  yu<?=pc.size();
	  for (int e=random(yu); kk!=pc.end()&&e>0; kk++, e--) ciel=kk->k;
	  mam_ciel=1; return kam(ciel, map);
  }
  if (pc.empty()&&mam_ciel==0) {
   	  mam_ciel=2; ciel.x=mapw/4+random(mapw/2); ciel.y=maph/4+random(maph/2);
  }
  /*cout <<endl; cout<<ID_SEQ(ent.id)<<" "<<pc.size();
	cout<<ciel.x<<" "<<ciel.y<<endl;
	cout<<sur.x<<" a "<<sur.y<<endl;*/
  return kam(ciel, map);
  /*  for (int j=0; j<MAP_SIZE; j++) for (int i=0; i<MAP_SIZE; i++) 
     if ( (ID_TYPE(map.field[i][j]) == etBase) && 
          (ID_PLAYER(map.field[i][j]) == ID_PLAYER(ent.id)) && ent.sugar) {
	  // chod smerom k zakladni odovzdat cukor
	  int dx=i-MAP_SIZE/2;
	  int dy=j-MAP_SIZE/2;
	  if ((dx<0) &&  (dy<0))  if (dx<dy) return dirDown; else return dirLeft;
	  if ((dx<0) &&  (dy>=0)) if (-dx<dy) return dirUp; else return dirLeft;
	  if ((dx>=0) && (dy<0))  if (dx<-dy) return dirDown; else return dirRight;
	  if ((dx>=0) && (dy>=0)) if (dx<dy) return dirUp; else return dirRight;
	}
  return random(5);*/
}

