#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>

#include "config.h"

// my own data
TEntity base;

int prizeWorker=0;
int prizeFighter=0;

int kamX,kamY;

extern char *PlayerName;

//--------------------------------------------------------
#define WHERE_IS_SUGAR 0
#define SUGAR          1
#define ENEMY_SPOTTED  2

#define GO_TO_HELL 0
#define FIND_SUGAR 1
#define GET_SUGAR 2
#define GO_HOME 3
#define GO_TO_HALL 4
#define maxInt 987654321
#define MAXINT 9876543

TGlobalMap Map;
int homeX,homeY,sugarX,sugarY,mapX,mapY,cx,cy,mode;
int tahov;
int vzd[GLOBAL_MAP_SIZE][GLOBAL_MAP_SIZE];
int whereX,whereY;
int lastX,lastY,kolko_cakam,JA;
int kolkoMam;
//--------------------------------------------------------

// born
//   called when the entity borns
//    ent          -- this entity (id, coordinates, ...)
//    nplayers     -- number of players in a game
//    map_w,map_h  -- coordinates, size of the map

int sqr(int x){ return x*x;}

int turn_right(int tah){
	switch(tah){
		case dirUp:return dirRight;
		case dirRight:return dirDown;
		case dirDown:return dirLeft;
		case dirLeft:return dirUp;
	}
}

int can_go(TMap map,int x,int y,int dx,int dy){
/*	if((ID_TYPE(map.field[x+dy][y+dy])==etEmpty)&&(!((ID_SUGAR(map.field[x][y])>0)&&(ID_SUGAR(map.field[x+dx][y+dy])>0))))return 1;else return 0;* */
	if ((ID_SUGAR(map.field[x][y])>0)&&(ID_SUGAR(map.field[x+dx][y+dy])>0)) return 0;
	return ID_TYPE(map.field[x+dx][y+dy])==etEmpty?1:0;
}

int find_home(TEntity ent,TMap map){
	int i,j,dx,dy;
	for(i=0;i<MAP_SIZE;i++)
		for(j=0;j<MAP_SIZE;j++)
			if((ID_TYPE(map.field[i][j])==etBase)&&(ID_PLAYER(map.field[i][j])==JA)){
				homeX=i+ent.x-MAP_SIZE/2;
				homeY=j+ent.y-MAP_SIZE/2;
				return 0;
        }
	for(i=0;i<MAP_SIZE;i++)
		for(j=0;j<MAP_SIZE;j++)
			if(ID_PLAYER(map.field[i][j])!=JA){dx-=i-MAP_SIZE/2;dy-=j-MAP_SIZE/2;}

//  printf("%d %d",homeX,homeY);
  return 0;
}

int find_sugar(TEntity ent,TMap map){
	int i,j;
	for(i=0;i<MAP_SIZE;i++)
		for(j=0;j<MAP_SIZE;j++)
			if(ID_SUGAR(map.field[i][j])){
				//Nasiel som cukor!!!
				sugarX=i+ent.x-MAP_SIZE/2;
				sugarY=j+ent.y-MAP_SIZE/2;
				return 1;
			}
	return 0;
}

int is_sugar(TEntity ent,TMap map){
	int i,j,dx,dy;
	for(i=0;i<MAP_SIZE;i++)
		for(j=0;j<MAP_SIZE;j++)
			if(ID_PLAYER(map.field[i][j])!=JA)
	       		        if(ID_SUGAR(map.field[i][j])){
				//Nasiel som cukor!!!)
				{dx-=i-MAP_SIZE/2;dy-=j-MAP_SIZE/2;}
                                  return 1;
				}
	return 0;
}

int set_way(){
	cx=random(Map.w-10)+5;//base.x+10*(random(2)*2-1);
	cy=random(Map.h-10)+5;//base.y+10*(random(2)*2-1);
//	if(cx<1)cx=1;
//	if(cy<1)cx=1;
//	if(cx>Map.w-2)cx=Map.w-2;
//	if(cy>Map.h-2)cy=Map.h-2;
	return 0;

}

int is_free(int x,int y,TMap map){
	int i,j,dx,dy;
	for(i=0;i<MAP_SIZE;i++)
		for(j=0;j<MAP_SIZE;j++)
			if((ID_TYPE(map.field[x][y])==etEmpty)&&(ID_PLAYER(map.field[i][j])!=JA)&&(!((ID_SUGAR(map.field[MAP_SIZE/2][MAP_SIZE/2])>0)&&(ID_SUGAR(map.field[x][y])>0)))){  dx-=i-MAP_SIZE/2;dy-=j,MAP_SIZE/2;return 1;}
	return 0;
}

	bool jeStena(int x, int y){
	  //if ((x<0)||(y<0))
	  return ID_TYPE(Map.field[x][y]==etWall);
	}

int prehladaj(){
	int i,j,zac,kon,x,y,vzdial;
	int fronta[(GLOBAL_MAP_SIZE+3)*GLOBAL_MAP_SIZE+10];
	zac=kon=1;
	for (i=0;i<GLOBAL_MAP_SIZE;i++)
		for (j=0;j<GLOBAL_MAP_SIZE;j++) vzd[i][j]=maxInt;
	fronta[0]=whereX*GLOBAL_MAP_SIZE+whereY;
	fronta[1]=-1;
	vzdial=0;
	if (jeStena(whereX,whereY)) return 0;
	vzd[whereX][whereY]=0;
	while (zac<=kon){
		if (fronta[zac]==-1){vzdial++;fronta[++kon]=-1; continue;}
		y=fronta[zac]%GLOBAL_MAP_SIZE;
		x=fronta[zac]/GLOBAL_MAP_SIZE;
		vzd[x][y]=vzdial;
		zac++;
		if (!jeStena(x+1,y))fronta[++kon]=(x+1)*GLOBAL_MAP_SIZE+y;
		if (!jeStena(x-1,y))fronta[++kon]=(x-1)*GLOBAL_MAP_SIZE+y;
		if (!jeStena(x,y+1))fronta[++kon]=x*GLOBAL_MAP_SIZE+y+1;
		if (!jeStena(x,y-1))fronta[++kon]=x*GLOBAL_MAP_SIZE+y-1;
	}
}

int mode_go_to_hell(){
	prehladaj();
	mode=GO_TO_HELL;
	cx=homeX-5*(random(2)*2-1);
	cy=homeY+5*(random(2)*2-1);
	tahov=0;
	return 0;
}

int mode_find_sugar(){
	mode=FIND_SUGAR;
	set_way();
	return 0;
}

int mode_get_sugar(){
	mode=GET_SUGAR;
	return 0;
}

int mode_go_home(){
	mode=GO_HOME;
	return 0;
}

int mode_go_to_hall(){
	mode=GO_TO_HALL;
	cx=homeX+random(14)-7;
	cy=homeY+random(14)-7;
	return 0;
}

int na_smer(int dx, int dy){
  if((dx==0)&&(dy==0))return dirStay;
  if (abs(dx)>abs(dy)){
	  if(dx<0) return dirLeft; else return dirRight;
		  }else {
	  if(dy<0)return dirDown; else return dirUp;
		  }

}

int born(TEntity ent, int nplayers, int map_w, int map_h, int pr_worker, int pr_fighter){
	srand(time(NULL)+ent.x*ent.y);
	base = ent;
        sprintf(PlayerName,"CTRL-ALT-DELETE");
	homeX=-1;
	homeY=-1;
	sugarX=-1;
	sugarY=-1;
	cx=-1;
	cy=-1;
        Map.w=map_w;
	Map.h=map_h;

	Map.prizeWorker=pr_worker;
	Map.prizeFighter=pr_fighter;
	
	JA=-1;
		
	mode_go_to_hell();
	int i,j;
	for(i=0;i<map_w;i++)
		for(j=0;j<map_h;j++)
			Map.field[i][j]=etWall;
	lastX=ent.x; lastY=ent.y; kolko_cakam=0;
	kolkoMam=0;
	kamY=ent.y; kamX=Map.w-ent.x;
	return random(5);
}

// step_(base|fighter|worker)
//   make a single step of a given entity
//    ent          -- this entity (id, coordinates, ...)
//    map          -- part of map visible around entity (with other entities)
//
//    *out_msg     -- message to send
//    returns direction to move in
int pocet(TMap map){
  int i,j,poc=0;
  for(i=0;i<MAP_SIZE;i++)
	  for(j=0;j<MAP_SIZE;j++)
		  if(ID_TYPE(map.field[i][j])==etWorker)poc++;
  return poc;		  
}

int step_base(TEntity ent, TMap map, TEntityCount cnt, TMessage *out_msg)
{
//  if ((cnt.fighters+cnt.workers<kolkoMam)&&(ent.sugar>=prizeFighter+prizeWorker/1.75)){kolkoMam++; return bornFighter;} 	
  int pl=ID_PLAYER(ent.id);
  static int poc=500;
  if(cnt.workers==0)return bornWorker;
  if(kolkoMam<cnt.workers-1)poc=500;
  kolkoMam=cnt.workers;
  if (--poc<175)poc=175;
 if (random(11)<poc/50) {
    if (ent.sugar >= prizeWorker+prizeFighter) {return bornFighter;}
  }// else {
    if ((pocet(map)<MAP_SIZE*MAP_SIZE/5)&&(ent.sugar >= prizeWorker*2)){ return bornWorker;}
//  }
  
  return bornNone;
}
int nezavadzaj(TMap map){
	int i,j,dx=0,dy=0;
	for(i=0;i<3;i++){
		if(ID_PLAYER(map.field[MAP_SIZE/2+i-1][MAP_SIZE/2+1])==JA){dx+=i-1;dy+=1;}
		if(ID_PLAYER(map.field[MAP_SIZE/2+i-1][MAP_SIZE/2-1])==JA){dx+=i-1;dy-=1;}
	}
	if(ID_PLAYER(map.field[MAP_SIZE/2+1][MAP_SIZE/2])==JA)dx+=1;
        if(ID_PLAYER(map.field[MAP_SIZE/2-1][MAP_SIZE/2])==JA)dx-=1;
	for(i=0;i<MAP_SIZE;i++)
		for(j=0;j<MAP_SIZE;j++)
			if((ID_PLAYER(map.field[i][j])!=JA)&&
			   (ID_TYPE(map.field[i][j])!=etEmpty)&&
			   (ID_TYPE(map.field[i][j])!=etWall)){
				if(i-MAP_SIZE/2<0)dx-=i-MAP_SIZE;else dx-=MAP_SIZE-i;
				if(j<MAP_SIZE/2<0)dy-=j-MAP_SIZE;else dy-=MAP_SIZE-j;
			}
	return na_smer(-dx,-dy);
}

int fighterSteps=0;

int step_fighter(TEntity ent, TMap map, TMessage *out_msg)
{
	base=ent;
	if(JA==-1)JA=ID_PLAYER(ent.id);
	if((homeX<0)||(homeY<0))find_home(ent,map);
	float min=MAXINT,pom;
	int kdeX,kdeY,i,j;
	if ((lastX==ent.x)&&(lastY==ent.y)){
		tahov++;
		fighterSteps=MAXINT;
	}else tahov=0;
	if (tahov==2) fighterSteps=MAXINT;
	lastX=ent.x; lastY=ent.y;
	for (i=0;i<MAP_SIZE;i++)
		for (j=0;j<MAP_SIZE;j++){
			if ((i==MAP_SIZE/2)&&(j==MAP_SIZE/2)) continue;
			if ((ID_PLAYER(map.field[i][j])!=JA)&&(ID_PLAYER(map.field[i][j])!=0)&&(ID_TYPE(map.field[i][j])!=etBase)){
				pom=sqr(i-MAP_SIZE/2)+sqr(j-MAP_SIZE/2);
				if (pom<min){
					min=pom;
					kdeX=i; kdeY=j;
				}
			}
		}
	if (min!=MAXINT){//nasiel som ho
		fighterSteps=MAXINT;
		tahov=0;
		return na_smer(kdeX-MAP_SIZE/2,kdeY-MAP_SIZE/2);
	}else{
		fighterSteps++;
		if (fighterSteps>MAP_SIZE*4){
			fighterSteps=0;
			kamX=random(Map.w); kamY=random(Map.h);
		}
		return na_smer(kamX-ent.x,kamY-ent.y);
	}
/*	int dx,dy,s,smer;//,whereX,whereY;
	s=nezavadzaj(map);
	if(s!=dirStay){set_way();return s;}
	return random(5);
	if((abs(cx-ent.x)<4)&&(abs(cy-ent.y)<4))set_way();
	whereX=cx;
	whereY=cy;
	dx=whereX-ent.x;
	dy=whereY-ent.y;
	smer=na_smer(dx,dy);
	for (int i=0;i<4;i++){
		
		switch (smer){
			case dirLeft: dx=-1; dy=0; break;
			case dirRight: dx=1; dy=0; break;
			case dirUp: dx=0; dy=-1; break;
			case dirDown: dx=0; dy=1; break;	    			
			
		}
		
		if (can_go(map,MAP_SIZE/2,MAP_SIZE/2,dx,dy)==1) return smer; else smer=turn_right(smer);			
	}


	return random(5);*/
}

int save_map(TEntity ent,TMap map){
	int i,j;
	for(i=0;i<MAP_SIZE;i++)
		for(j=0;j<MAP_SIZE;j++)
			Map.field[ent.x+i-MAP_SIZE/2][ent.y+j-MAP_SIZE/2]=map.field[i][j];
	return 0;
}


int zdrhaj_pred_nosicom(TMap map){//dorobit, aby ignoroval vojakov->HOTOVO, treba dorobit zdrhanie pred nepriatelom
	int i,j,dx=0,dy=0;
	for(i=0;i<3;i++){
		if((ID_PLAYER(map.field[MAP_SIZE/2+i-1][MAP_SIZE/2+1])==JA)&&
		     (ID_TYPE(map.field[MAP_SIZE/2+i-1][MAP_SIZE/2+1])==etWorker)){dx+=i-1;dy+=1;}
		if((ID_PLAYER(map.field[MAP_SIZE/2+i-1][MAP_SIZE/2-1])==JA)&&
		     (ID_TYPE(map.field[MAP_SIZE/2+i-1][MAP_SIZE/2-1])==etWorker)){dx+=i-1;dy-=1;}
	}
	if((ID_PLAYER(map.field[MAP_SIZE/2+1][MAP_SIZE/2])==JA)&&
	     (ID_TYPE(map.field[MAP_SIZE/2+1][MAP_SIZE/2])==etWorker))dx+=1;
	if((ID_PLAYER(map.field[MAP_SIZE/2-1][MAP_SIZE/2])==JA)&&
	     (ID_TYPE(map.field[MAP_SIZE/2-1][MAP_SIZE/2])==etWorker))dx-=1;
	return na_smer(-dx,-dy);
}

int enemy_spoted(TMap map){
		int i,j,dx=0,dy=0;
	for(i=0;i<MAP_SIZE;i++)
		for(j=0;j<MAP_SIZE;j++)
			if((ID_PLAYER(map.field[i][j])!=JA)&&(ID_TYPE(map.field[i][j]==etFighter))){
				if(i-MAP_SIZE/2<0)dx-=i-MAP_SIZE;else dx-=MAP_SIZE-i;
				if(j<MAP_SIZE/2<0)dy-=j-MAP_SIZE;else dy-=MAP_SIZE-j;
                        }
	return na_smer(-dx,-dy);
}

int step_worker(TEntity ent, TMap map, TMessage *out_msg)
{
	base=ent;
	if(JA==-1)JA=ID_PLAYER(ent.id);
	if((ent.sugar>0)&&(mode!=GO_HOME))mode_go_home();//mode_go_to_hall();

	save_map(ent,map);
	int whereX,whereY,dx,dy,smer,s;
	s=enemy_spoted(map);
	if(s!=dirStay)return s;
	if((ent.sugar==0)&&(mode!=FIND_SUGAR)){
		s=zdrhaj_pred_nosicom(map);
		if(s!=dirStay){
			if((mode==GO_TO_HELL)||(mode==FIND_SUGAR))set_way();
			return s;
		}
	}
	if((lastX==ent.x)&&(lastY==ent.y)){
	  kolko_cakam++;
	  return random(5);//mode_go_to_hell();
	}else{
	  lastX=ent.x;
	  lastY=ent.y;
	  kolko_cakam=0;
	}
	if((homeX<0)||(homeY<0)){
		find_home(ent,map);
		mode_go_to_hell();
		
	}
	switch(mode){//co vlastne globalne robim?
		case GO_TO_HELL:
//			whereX=cx;
//			whereY=cy;
			if (tahov++<10)return random(5);
			if((ent.x==cx)&&(ent.y==cy)||(tahov>3))mode_find_sugar();
		break;
		case FIND_SUGAR:
			if((abs(ent.x-cx)<3)&&(abs(ent.y-cy)<3))set_way();
			whereX=cx;
			whereY=cy;
			if(find_sugar(ent,map))mode_get_sugar();
		break;
		case GET_SUGAR:
			if((ent.x==sugarX)&&(ent.y==sugarY)&&(is_sugar(ent,map)==0))mode_find_sugar();		
			whereX=sugarX;
			whereY=sugarY;
			if(ent.sugar>0)mode_go_to_hall();
		break;
		case GO_TO_HALL:
			if((abs(ent.x-cx)<6)&&(abs(ent.y-cy)<6))mode_go_home();
			whereX=cx;
			whereY=cy;
			if(ent.sugar==0)mode_go_to_hell();
		break;
		case GO_HOME:
			whereX=homeX;
			whereY=homeY;
			if(ent.sugar==0)mode_go_to_hell();
		break;
		default: if(ent.sugar>0)mode_go_home();else mode_find_sugar();
	}//Ked uz to viem, tak to idem robit
	dx=whereX-ent.x;
	dy=whereY-ent.y;
	smer=na_smer(dx,dy);
	for (int i=0;i<4;i++){
		
		switch (smer){
			case dirLeft: dx=-1; dy=0; break;
			case dirRight: dx=1; dy=0; break;
			case dirUp: dx=0; dy=-1; break;
			case dirDown: dx=0; dy=1; break;	    			
			
		}
		
		if (can_go(map,MAP_SIZE/2,MAP_SIZE/2,dx,dy)==1) return smer; else smer=turn_right(smer);			
	}
}

