// ******************************************************************\
//   ProbaBalistic ;) player
//
//   TODO
//        BFS - nepouzivane
//        historia cukru  - nepouziva sa este
//        celkovo rozumnejsia baza - podla vzdialenosti cukru, vojakov
//        zaplnenost ovahovat vzialenostne
//
//        ked je preplnene pri baze, dorpneme a ideme prec
//        
//	  EKONOMIKA
//
//        FIGHTERY
//

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
//#include <math.h>

#include "config.h"

extern char *PlayerName;

#define PL_NAME "ProbaBalistic v1.8"

// MAGIC
#define W_GoodDirB  10000	    // smerom k base
#define W_GoodDirBK  20	    // kolmo na smer k base, ak sme na jej urovni... (kvoli dialniciam ak su)
#define W_GoodDirS   1000000    // smerom k cukru

#define W_LAST_PREF  10000    // posledny smer pri prehladavani cukru (exp sa zmensuje)
#define W_LAST_PREF_F  100000    // posledny smer pri prehladavani cukru (exp sa zmensuje) FIGHTER

#define W_UTEKAME_S  -1000	// utekame od cudzich fighterov ked mame cukor
#define W_UTEKAME_NS  -10	// utekame od cudzich fighterov ked NEmame cukor
#define W_ATTACK_ANT 100000       // utok na cudzieho mravca
#define W_ATTACK_BASE 1000       // utok na cudziu bazu
#define W_SEND_PREF 1000000	// posielanie sprav

#define SUGAR_HIST_SIZE	50	

#define MIN_DIST_TO_ASK  6

#define MAX_NARAZENI 2	    // kolkokrat skusame pohnut sana policko, kde uz niekto je

#define MAX_FILL_FOR_NEW 0.2   // zaplnenie pod ktorym este vyrabame workerov

#define BASE_GUARD 3

#define MAX_WORKERS 1000
#define MAX_FIGHTERS 18
#define REZERVA_W 2
#define MAX_BFS  (GLOBAL_MAP_SIZE)   

#define MAX_DSTEPS 20


#define DIALNICE 0	    // ci su dialnice
#define FILL_F    0	//  ci  koef zaplnenia ovplyvnuje smer k base
#define FILL_F_DIR  1   // ci koef zaplnenia v smere ovplyvnuje smer k base

#define SHOW_PREFS 0

double fill_f( double x) 
{  if (!FILL_F) return 1;      return  x<0.5 ? 1 : 2.0 - 2.0*x  ; }

double fill_f_dir( double x) 
{  if (!FILL_F_DIR)  return(1);    return  x<0.2 ? 1 : 5/4.0 - 5.0*x/4.0    ; }


#define sqr(x) ((x)*(x))
#define pow2(x) (1<<( (x)<6?(x):6 ) )

static int loglog(int a)
{
    if (a<=0) return 0;
//    return (int)(a/50+1);
    return (1);
}

static long long int cukor_za_dst(int cukru, int dst ) {
 return W_GoodDirS * loglog( cukru ) / sqr(pow2( dst ));
}

static long long int fight_dist(int dst, long long W ) {
    if (dst<=2) return W*100;
    if (dst<=3) return W*20;
    return W * 20 / dst;
}


// ****************************************
//  odtialto nemeniace


// const MSG
#define m_WHERE_SUGAR 1 
#define m_SUGAR_THERE 2



// my own data
TEntity base;

// ***********************************************
//  global

static FILE *F;

static int prizeWorker=0;
static int prizeFighter=0;

static int atlas_w, atlas_h;
static TID atlas[GLOBAL_MAP_SIZE][GLOBAL_MAP_SIZE];
static int sugar_hist[SUGAR_HIST_SIZE],sh_p=0;


static int base_x,base_y;
static int my_age = 0;
static int my_type = etWorker;
static int my_player = 1;

static long long int prefs[10];
static int sum=0;

static double k_fill=0.001;
static double k_fill_left=0.001;
static double k_fill_right=0.001;
static double k_fill_up=0.001;
static double k_fill_down=0.001;

static int pytal_som_sa=0;

static int last_dir,  last_pref;
static int last_x=1,last_y=1;
static int narazame=0;

static int a__sug=0;
static int a__sugx=0;
static int a__sugy=0;

static int  bfs_dist[GLOBAL_MAP_SIZE][GLOBAL_MAP_SIZE];
static int  bfs_dir[GLOBAL_MAP_SIZE][GLOBAL_MAP_SIZE];
static char bfs_q[GLOBAL_MAP_SIZE*GLOBAL_MAP_SIZE*2+100];
static int bfs_l, bfs_r;


static int fdx, fdy, fdsteps;

static int explored[GLOBAL_MAP_SIZE][GLOBAL_MAP_SIZE];

static int MAP_S = MAP_SIZE/2;


static int mk_message3(char type, char x, char y, char z){
    return (type << 24) | (x << 16) | (y << 8) | z;
}

static int dmesg3(int m, char *t, char *x, char *y, char *z )
{
    *z = m & 0xff;
    m = m>>8; *y = m & 0xff;
    m = m>>8; *x = m & 0xff;
    m = m>>8; *t = m & 0xff;
    return 0;
}



static void bfs_ins( int sx, int sy, int x, int y, int d, int dir)
{
    if (x<0 || y<0 || x>=atlas_w || y>=atlas_h ) return;
    if ( bfs_dist[x][y] ) return;
    if ( ID_TYPE(atlas[x][y]) == etWall ) return;
    if ( ID_SUGAR(atlas[sx][sy]) && ID_SUGAR(atlas[sx][sy]))  return;

    if ( my_type == etWorker) {
        if ( ID_TYPE(atlas[x][y]) == etWorker ) return;
        if ( ID_TYPE(atlas[x][y]) == etFighter ) return;
        if ( ID_TYPE(atlas[x][y]) == etBase ) return;
    } else {
	if ( ID_PLAYER(atlas[x][y])==my_player ) return;
    }

    if (d == 1) 
	bfs_dir[x][y] = dir;
    else
	bfs_dir[x][y] = bfs_dir[sx][sy];
    
    bfs_q[bfs_r++] = x;
    bfs_q[bfs_r++] = y;
    bfs_dist[x][y] = d+1;
}

static void bfs( int xx, int yy, int h )
{
    int x,y;
    bfs_l = bfs_r = 0;
    
    bzero( bfs_dist, sizeof(bfs_dist) );
    bzero( bfs_dir, sizeof(bfs_dir) );

    bfs_q[bfs_r++] = xx;
    bfs_q[bfs_r++] = yy;
    bfs_dist[xx][yy] = 1;
    
    while (bfs_l<bfs_r) {
	x = bfs_q[bfs_l++];
	y = bfs_q[bfs_l++];
	if (bfs_dist[x][y] < h ) {
	    bfs_ins( x, y, x+1, y, bfs_dist[x][y], dirRight ); 
	    bfs_ins( x, y, x, y-1, bfs_dist[x][y], dirDown );
	    bfs_ins( x, y, x-1, y, bfs_dist[x][y], dirLeft );
	    bfs_ins( x, y, x, y+1, bfs_dist[x][y], dirUp );
	}
	
    }
    for ( int i=0; i<atlas_w; i++)
	for ( int j=0; j<atlas_h; j++)
	    if (!bfs_dist[i][j]) bfs_dist[i][j] = h+1;
}


static int max( int a, int b)
{
    return a>b ? a : b;
}

static int min( int a, int b)
{
    return a<b ? a : b;
}


   

static int irandom( int x) {
    return rand()%x;
}


static int w_random( long long int *prefs, int size )
{
        int sum,r,i;
       
        sum=0;
	for(i=0; i<size; i++) sum+=max(prefs[i],0);
	r=irandom(sum);
        
	sum=0;
	i=0;
	while (sum<=r && i<size) sum+=max(prefs[i++],0);

        return i-1;
}


static int dist( int a, int b, int c, int d )
{
    return abs(c-a)+abs(d-b);
}

static int find_sugar( char *xx, char *yy ) {
    int i,j,min;

    if (a__sug) {
	*xx = a__sugx;
	*yy = a__sugy;
	return 1;
    }
    
    min = GLOBAL_MAP_SIZE*GLOBAL_MAP_SIZE*2;
    
    *xx==0; *yy=0;
    for (i=0; i<GLOBAL_MAP_SIZE; i++)
	for (j=0; j<GLOBAL_MAP_SIZE; j++)
	    if (ID_SUGAR(atlas[i][j]) && dist(i,j,base_x, base_y)<min ) {
		min =  dist(i,j,base_x, base_y);
		*xx = i;
		*yy = j;
	    }
    if (min<=GLOBAL_MAP_SIZE*GLOBAL_MAP_SIZE)  {
	a__sug = 1;
	a__sugx == *xx;
	a__sugy == *yy;
	return 1;
    }
	
    return 0;
}




// born
//   called when the entity borns
//    ent          -- this entity (id, coordinates, ...)
//    nplayers     -- number of players in a game
//    map_w,map_h  -- coordinates, size of the map
int born(TEntity ent, int nplayers, int map_w, int map_h, int pr_worker, int pr_fighter){
//srand(time(NULL)+ent.x*ent.y);
	srand(7777);
	base = ent;
	sh_p = 0;
	bzero( sugar_hist, sizeof(sugar_hist) );
	bzero( explored, sizeof(explored) );

	sprintf( PlayerName, PL_NAME );

	prizeWorker = pr_worker;
	prizeFighter = pr_fighter;
	atlas_w = map_w;
	atlas_h = map_h;
	my_type = ID_TYPE(ent.id);
	my_player = ID_PLAYER(ent.id);
	my_age = 0;
	fdsteps = 0;

/*	
	char s[50];
	sprintf( s, "/tmp/yoyo_R.%08X", ent.id );
	F = fopen( s, "w" );
  */
	return dirStay;
}



// step_(base|fighter|worker)
//   make a single step of a given entity
//    ent          -- this entity (id, coordinates, ...)
//    map          -- part of map visible around entity (with other entities)
//
//    *out_msg     -- message to send
//    returns direction to move in



// ******************************************************************************
// 
//                      BASE

int step_base(TEntity ent, TMap map, TEntityCount cnt, TMessage *out_msg)
{
    int pl=ID_PLAYER(ent.id);
    int s,i,j,p=0, m_f, m_w;
    double k_fill;
    int ff = 0; 
    int pf = 3;

    // zratame k_fill;
    for (i=0; i<MAP_SIZE; i++)
	for (j=0; j<MAP_SIZE; j++) {
	    // koeficienty
	    if(ID_TYPE(map.field[i][j])==etWorker || ID_TYPE(map.field[i][j])==etFighter) {
		p++;
		if (i>MAP_SIZE/2) k_fill_right += 2.0/(MAP_SIZE*MAP_SIZE);
		if (i<MAP_SIZE/2) k_fill_left += 2.0/(MAP_SIZE*MAP_SIZE);
		if (j>MAP_SIZE/2) k_fill_up += 2.0/(MAP_SIZE*MAP_SIZE);
		if (j<MAP_SIZE/2) k_fill_down += 2.0/(MAP_SIZE*MAP_SIZE);
	    }
	}
    k_fill = p / (double)(MAP_SIZE*MAP_SIZE);


/*    sugar_hist[sh_p] = ent.sugar + prizeFighter*cnt.fighters + prizeWorker*cnt.workers; 
    
    s=0;
    for (i=0; i<5; i++) {
	int pom = sugar_hist[ (sh_p-i+SUGAR_HIST_SIZE)%SUGAR_HIST_SIZE ] - sugar_hist[ (sh_p-i-1+SUGAR_HIST_SIZE)%SUGAR_HIST_SIZE ];
	pom = max( pom, 0 );
	s += pom;
    }
    s = s/5;

    sh_p++;
    sh_p %= SUGAR_HIST_SIZE;
*/
//    fprintf( stdout, "  k_fill: %lf\n", k_fill );

   
    if (prizeWorker*5> prizeFighter) ff = 1; else ff=0;
    
   m_f = ent.sugar/prizeFighter;
   m_w = ent.sugar/prizeWorker;

//  if (m_f>3 && m_w>REZERVA_W) 
//	if (ff && random(10)<4 && cnt.fighters< MAX_FIGHTERS) return bornFighter;


    pf = 4;
    if (cnt.workers>10) pf=5;
   
    if ( ff && (random(10)<pf) && cnt.fighters < MAX_FIGHTERS && ent.sugar > prizeFighter && k_fill<0.4) return bornFighter;
    
    if (k_fill< ( MAX_FILL_FOR_NEW + 0.147*(1-ff) )      && cnt.workers<MAX_WORKERS  && ent.sugar> prizeWorker ) return bornWorker;
    
    if ( ff && ent.sugar > prizeWorker*REZERVA_W + prizeFighter && cnt.fighters<MAX_FIGHTERS) return bornFighter;
    
    return bornNone;
}



// *********************************************************************************
//
//                       FIGHTER

int step_fighter(TEntity ent, TMap map, TMessage *out_msg)
{
    int i,j,r=0, e=0,eb=0;
    my_age++;
    
    for (i=0; i<MAP_SIZE; i++)
	for (j=0; j<MAP_SIZE; j++) {
	    atlas[ent.x+i-MAP_SIZE/2][ent.y+j-MAP_SIZE/2]=map.field[i][j];
	    if(ID_TYPE(map.field[i][j])==etBase) {
		base_x=ent.x+i-MAP_SIZE/2;
		base_y=ent.y+j-MAP_SIZE/2;
	    }
	}
    
    for(i=0;i<10;i++)prefs[i]=0;
    prefs[dirUp]=1;
    prefs[dirLeft]=1;
    prefs[dirRight]=1;
    prefs[dirDown]=1;
  

    bfs( ent.x, ent.y, MAX_BFS);
    
    for (i=0; i<atlas_w; i++)
	for (j=0; j<atlas_h; j++) {
	    if (ID_PLAYER(atlas[i][j]) != my_player && ID_PLAYER(atlas[i][j])!=0) {
		
		if ((ID_TYPE(atlas[i][j]) == etWorker || ID_TYPE(atlas[i][j]) == etFighter)  )   e++;
		if (ID_TYPE(atlas[i][j]) == etBase) eb++;
		
		if (ID_TYPE(atlas[i][j]) == etBase) {
		    //base....
		    int p = 0;
		    for( int a=max(i-5,0); a<min(i+5,GLOBAL_MAP_SIZE); a++)
			for( int b=max(i-5,0); b<min(i+5,GLOBAL_MAP_SIZE); b++) {
			    if (ID_PLAYER(atlas[a][b])==my_player&& ID_TYPE(atlas[a][b])==etFighter) p++;
			}
//		    printf (" zaplnena basa : %d           \n", p);
		    if( dist(ent.x,ent.y,i,j)<1 || p<BASE_GUARD ) {
//			printf( "ideme za nou              \n");
			e++;
			if (bfs_dist[i][j]<=MAX_BFS) {
			    prefs[ bfs_dir[i][j] ] += fight_dist(bfs_dist[i][j], W_ATTACK_BASE) ;
			}
			else {
			    if(i>ent.x) prefs[dirRight]+=W_ATTACK_BASE ;
			    if(i<ent.x) prefs[dirLeft]+=W_ATTACK_BASE;
			    if(j>ent.y) prefs[dirUp]+=W_ATTACK_BASE ;
			    if(j<ent.y) prefs[dirDown]+=W_ATTACK_BASE; 
			}
			
		    }
		}
		else {
		    if (bfs_dist[i][j]<=MAX_BFS) {
			prefs[ bfs_dir[i][j] ] += fight_dist(bfs_dist[i][j], W_ATTACK_ANT) ;
		    }
		    else {
			if(i>ent.x) prefs[dirRight]+=W_ATTACK_ANT;
			if(i<ent.x) prefs[dirLeft]+=W_ATTACK_ANT; 
			if(j>ent.y) prefs[dirUp]+=W_ATTACK_ANT ;
			if(j<ent.y) prefs[dirDown]+=W_ATTACK_ANT; 
		    }
		}
	    } // koniec cudzich
	}
    
    if (!e) {
	prefs[dirUp]=1;
	prefs[dirLeft]=1;
	prefs[dirRight]=1;
	prefs[dirDown]=1;
	if (fdsteps<=0) {
	    fdx = random(atlas_w);
	    fdy = random(atlas_h);
	    fdsteps = random(MAX_DSTEPS)+MAX_DSTEPS/2;
//	    printf("making dest at %d %d steps %d           \n", fdx, fdy, fdsteps );
	}

	fdsteps--;
//	printf("going for  dest at %d %d steps %d           \n", fdx, fdy, fdsteps );
	if (bfs_dist[fdx][fdy]<=MAX_BFS) {
//	    printf( " bfs_dir : %d         \n", bfs_dir[fdx][fdy] );
	    prefs[ bfs_dir[fdx][fdy] ] += fight_dist(bfs_dist[fdx][fdy],W_ATTACK_ANT) ;
	}
	else {
	    if(fdx>ent.x) prefs[dirRight]+=W_ATTACK_ANT ;
	    if(fdx<ent.x) prefs[dirLeft]+=W_ATTACK_ANT; 
	    if(fdy>ent.y) prefs[dirUp]+=W_ATTACK_ANT ;
	    if(fdy<ent.y) prefs[dirDown]+=W_ATTACK_ANT; 
	}
	
    }

   
    if (dist(ent.x,ent.y,base_x,base_y)<3) {
	for( int i=1; i<=4 ; i++) prefs[i] = W_ATTACK_ANT;
	if(base_x>ent.x) prefs[dirRight] /=3 ;
	if(base_x<ent.x) prefs[dirLeft] /=3;
	if(base_y>ent.y) prefs[dirUp] /=3 ;
	if(base_y<ent.y) prefs[dirDown] /=3; 
	
    }
    
    // ani sa nesnazme ist do steny
    if (ID_TYPE(map.field[MAP_S-1][MAP_S])==etWall) prefs[dirLeft] = 0;
    if (ID_TYPE(map.field[MAP_S+1][MAP_S])==etWall) prefs[dirRight] = 0;
    if (ID_TYPE(map.field[MAP_S][MAP_S-1])==etWall) prefs[dirDown] = 0;
    if (ID_TYPE(map.field[MAP_S][MAP_S+1])==etWall) prefs[dirUp] = 0;
   
    // z cukru na cukor
    if (ID_SUGAR(map.field[MAP_S][MAP_S])) {
	if (ID_SUGAR(map.field[MAP_S-1][MAP_S])) prefs[dirLeft] = 0;
	if (ID_SUGAR(map.field[MAP_S+1][MAP_S])) prefs[dirRight] = 0;
	if (ID_SUGAR(map.field[MAP_S][MAP_S+1])) prefs[dirUp] = 0;
	if (ID_SUGAR(map.field[MAP_S][MAP_S-1])) prefs[dirDown] = 0;
    }

    
    
    //  JADRO  ale asi blbo rata...
    i = w_random( prefs, 10 );
    
    if (i != last_dir) {
	last_dir = i;
	last_pref = W_LAST_PREF_F;
    } else {
	last_pref /= 2;
    }


    if (SHOW_PREFS) {
	printf (" pref left  %10lld                                          \n", prefs[dirLeft] );
	printf (" pref right %10lld                                          \n", prefs[dirRight] );
	printf (" pref up    %10lld                                          \n", prefs[dirUp] );
	printf (" pref down  %10lld                                          \n", prefs[dirDown] );
	printf (" chosen     %d                                  \n", i );

	printf( "\n==============\n                                                   \n" );
	printf( "                                                   \n" );
	printf( "                                                   \n" );
	printf( "                                                   \n" );
	printf( "                                                   \n" );
    }
    
    return i;
}



// *********************************************************************************
//
//                       WORKER


int step_worker(TEntity ent, TMap map, TMessage *out_msg)
{
    int i,j,r=0,p=0, f=0;

    int ne_l=0, ne_r=0, ne_u=0, ne_d=0;
    long long int cukr_prefs[10]; 

//    fprintf( stderr, "start\n");
    a__sug=0;
    k_fill_left = 0;
    k_fill_right = 0;
    k_fill_up = 0;
    k_fill_down = 0;

    // reset pravdepodobnosti
    bzero( prefs, sizeof(prefs) );
    bzero( cukr_prefs, sizeof(cukr_prefs) );
    prefs[dirUp]=17;
    prefs[dirLeft]=17;
    prefs[dirRight]=17;
    prefs[dirDown]=17;

    // pozrieme  messages
    for(i=0; i<ent.in_msgs; i++) {
	char x,y,z,typ;
	dmesg3( ent.in_msg[i].msg, &typ, &x, &y, &z );
//	fprintf( F, "doslo: (my_id: 0x%08X)  msg: 0x%08X   id: 0x%08X               \n", ent.id, ent.in_msg[i].msg, ent.in_msg[i].id );
//	fflush(F)
	switch (ent.in_msg[i].msg>>24) {
	    case m_SUGAR_THERE:	    SET_SUGAR( atlas[x][y], z); break;
				    
	    case m_WHERE_SUGAR:	    if (find_sugar(&x,&y)) {
					out_msg->msg = mk_message3(m_SUGAR_THERE, x, y ,ID_SUGAR(atlas[x][y]) );
					out_msg->id = ent.in_msg[i].id;
				    }
				    prefs[dirSend]+=W_SEND_PREF;
				    break;
				    
//	   default:    printf( "skapem: 0x%08X                                     \n", ent.in_msg[i].msg); fflush(stdout); exit(1);
	}
    }

    // skopirujeme mapu
    for (i=0; i<MAP_SIZE; i++)
	for (j=0; j<MAP_SIZE; j++) {
	    atlas[ent.x+i-MAP_SIZE/2][ent.y+j-MAP_SIZE/2]=map.field[i][j];
	    explored[ent.x+i-MAP_SIZE/2][ent.y+j-MAP_SIZE/2]=1;
	    
	    // baza
	    if(ID_TYPE(map.field[i][j])==etBase && ID_PLAYER(map.field[i][j])==ID_PLAYER(ent.id) ) {
		base_x=ent.x+i-MAP_SIZE/2;
		base_y=ent.y+j-MAP_SIZE/2;
	    }
	    // koeficienty
	    if(ID_TYPE(map.field[i][j])==etWorker || ID_TYPE(map.field[i][j])==etFighter) {
		p++;
		if (i>MAP_SIZE/2) k_fill_right += 2.0/(MAP_SIZE*MAP_SIZE);
		if (i<MAP_SIZE/2) k_fill_left += 2.0/(MAP_SIZE*MAP_SIZE);
		if (j>MAP_SIZE/2) k_fill_up += 2.0/(MAP_SIZE*MAP_SIZE);
		if (j<MAP_SIZE/2) k_fill_down += 2.0/(MAP_SIZE*MAP_SIZE);
	    }
	    // niekto nahodny z nasich (opytanie ....)
	    if(ID_PLAYER(map.field[i][j]) == ID_PLAYER(ent.id) && (ID_TYPE(map.field[i][j])==etWorker) && map.field[i][j] != ent.id)
		if(!f || random(10)<1) f=map.field[i][j];
	}
    k_fill = p / (double)(MAP_SIZE*MAP_SIZE);


    bfs( ent.x, ent.y, MAX_BFS);
    
    for (i=0; i<atlas_w; i++)
	for (j=0; j<atlas_h; j++) {
	    if (!explored[i][j]) {
		if (i>ent.x) ne_r++;
		if (i<ent.x) ne_l++;
		if (j>ent.y) ne_u++;
		if (j<ent.y) ne_d++;
	    }
	}
    
    
    // ************************
    //   mame cukor
    if (ent.sugar) {
	if (bfs_dist[base_x][base_y] <= MAX_BFS && dist(ent.x,ent.y,base_x,base_y)>4 ) {
	    prefs[ bfs_dir[base_x][base_y] ] += W_GoodDirB;
	} else {
	    if (base_x>ent.x+1) 
		prefs[dirRight]+=(int)( W_GoodDirB * fill_f(k_fill) );
	    if (base_x<ent.x-1) 
		prefs[dirLeft]+=(int)( W_GoodDirB * fill_f(k_fill) );
	    if (base_y>ent.y+1)
		prefs[dirUp]+=(int)( W_GoodDirB * fill_f(k_fill) );
	    if (base_y<ent.y-1)
		prefs[dirDown]+=(int)( W_GoodDirB * fill_f(k_fill) );
	}
	
	for (i=0; i<atlas_w; i++)
	    for (j=0; j<atlas_h; j++) {
		// utekame pred fightermi
		if (i>ent.x) prefs[dirRight]+=W_UTEKAME_S* (ID_PLAYER(atlas[i][j])!=ID_PLAYER(ent.id) && ID_TYPE(atlas[i][j])==etFighter ) / (abs(ent.x-i)+abs(ent.y-j)+1);
		if (i<ent.x) prefs[dirLeft]+=W_UTEKAME_S* (ID_PLAYER(atlas[i][j])!=ID_PLAYER(ent.id) && ID_TYPE(atlas[i][j])==etFighter ) / (abs(ent.x-i)+abs(ent.y-j)+1);
		if (j>ent.x) prefs[dirUp]+=W_UTEKAME_S* (ID_PLAYER(atlas[i][j])!=ID_PLAYER(ent.id) && ID_TYPE(atlas[i][j])==etFighter ) / (abs(ent.x-i)+abs(ent.y-j)+1);
		if (j<ent.x) prefs[dirDown]+=W_UTEKAME_S* (ID_PLAYER(atlas[i][j])!=ID_PLAYER(ent.id) && ID_TYPE(atlas[i][j])==etFighter ) / (abs(ent.x-i)+abs(ent.y-j)+1);
		
	    }
	if (DIALNICE) {
	    if (base_y==ent.y) {
		prefs[dirDown]+=W_GoodDirBK;
		prefs[dirUp]+=W_GoodDirBK;
	    }
	    if (base_x==ent.x) {
		prefs[dirLeft]+=W_GoodDirBK;
		prefs[dirRight]+=W_GoodDirBK;
	    }
	}
    }
  // ***************************
  //  NEmame cukor

    else{
      // podla cukru    
	int cukru=0;
	for (i=0; i<atlas_w; i++)
	    for (j=0; j<atlas_h; j++) {
		if (ID_SUGAR(atlas[i][j])) cukru++;
		if (ID_SUGAR(atlas[i][j])) {
//		    printf ( "cukor v atlase %d %d            \n", i,j);
//		    fprintf( stderr, " [%d %d] bfs_d : %d  sugar: %d\n", i, j, bfs_dist[i][j], ID_SUGAR(atlas[i][j])  );
//		    fprintf( stderr, " boost: %ld\n",  W_GoodDirS * loglog(ID_SUGAR(atlas[i][j])) / sqr(pow2(bfs_dist[i][j])) );

		    if (bfs_dist[i][j] > MAX_BFS ) {
//			printf(" NEBFS [%2d %2d] bfs_d: %3d  sugar: %3d boost: %7d\n", i, j, bfs_dist[i][j], ID_SUGAR(atlas[i][j]), W_GoodDirS * loglog(ID_SUGAR(atlas[i][j])) / sqr(pow2(bfs_dist[i][j])) );
			if (i>ent.x) cukr_prefs[dirRight] += cukor_za_dst( ID_SUGAR(atlas[i][j]) , bfs_dist[i][j] );
			if (i<ent.x) cukr_prefs[dirLeft] += cukor_za_dst( ID_SUGAR(atlas[i][j]) , bfs_dist[i][j] );
			if (j>ent.y) cukr_prefs[dirUp] += cukor_za_dst( ID_SUGAR(atlas[i][j]) , bfs_dist[i][j] );
			if (j<ent.y) cukr_prefs[dirDown] += cukor_za_dst( ID_SUGAR(atlas[i][j]) , bfs_dist[i][j] );
		    } 
		    else {
//			printf( "  BFS [%2d %2d] bfs_d: %3d boost: %7d  dir: %2d\n", i, j, bfs_dist[i][j], W_GoodDirS * loglog(ID_SUGAR(atlas[i][j])) / sqr(pow2(bfs_dist[i][j])), bfs_dir[i][j] );
			cukr_prefs[ bfs_dir[i][j] ]+= cukor_za_dst( ID_SUGAR(atlas[i][j]) , bfs_dist[i][j] );
		    }
		}
		// utekame pred fightermi
		if (i>ent.x) prefs[dirRight]+=W_UTEKAME_S* (ID_PLAYER(atlas[i][j])!=ID_PLAYER(ent.id) && ID_TYPE(atlas[i][j])==etFighter ) / (abs(ent.x-i)+abs(ent.y-j)+1);
		if (i<ent.x) prefs[dirLeft]+=W_UTEKAME_S* (ID_PLAYER(atlas[i][j])!=ID_PLAYER(ent.id) && ID_TYPE(atlas[i][j])==etFighter ) / (abs(ent.x-i)+abs(ent.y-j)+1);
		if (j>ent.x) prefs[dirUp]+=W_UTEKAME_S* (ID_PLAYER(atlas[i][j])!=ID_PLAYER(ent.id) && ID_TYPE(atlas[i][j])==etFighter ) / (abs(ent.x-i)+abs(ent.y-j)+1);
		if (j<ent.x) prefs[dirDown]+=W_UTEKAME_S* (ID_PLAYER(atlas[i][j])!=ID_PLAYER(ent.id) && ID_TYPE(atlas[i][j])==etFighter ) / (abs(ent.x-i)+abs(ent.y-j)+1);
		
	    }
//	printf( "nemam cukor, vidim %d cukru               \n", cukru );

	// vieme kde je cukor
	if (cukru) {
	    long long int max=0,tmp=0;
	    for(int i=1; i<10; i++ ) if (cukr_prefs[i]>cukr_prefs[max]) max = i;
	    tmp = cukr_prefs[max];
	    for (int i=0; i<10; i++) cukr_prefs[i] = cukr_prefs[i] * W_GoodDirS / tmp;
	    for (int i=0; i<10; i++) prefs[i] += cukr_prefs[i];
	    
	}
	// ***********************
	//  nevieme kde je cukor
	else {
	    // mozeme sa spytat
	    if(dist(ent.x, ent.y, base_x, base_y)>MIN_DIST_TO_ASK && f) {
		if ((pytal_som_sa<4) || (random(5)==0) ) {
		    out_msg->msg = mk_message3(m_WHERE_SUGAR, 0, 0, 0 );
		    out_msg->id = f;
//		    printf( "posielame: id:0x%08X   message: 0x%08X                         \n", out_msg->id, out_msg->msg );
		    prefs[dirSend] += W_SEND_PREF;
		    pytal_som_sa++;
		} else {
//		    prefs[last_dir] += last_pref;
		    if (fdsteps<=0) {
			fdx = random(atlas_w);
			fdy = random(atlas_h);
			fdsteps = random(MAX_DSTEPS)+MAX_DSTEPS/2;
//			printf("making dest at %d %d steps %d           \n", fdx, fdy, fdsteps );
		    }

		    fdsteps--;
//		    printf("going for  dest at %d %d steps %d           \n", fdx, fdy, fdsteps );
		    if (bfs_dist[fdx][fdy]<=MAX_BFS) {
//			printf( " bfs_dir : %d         \n", bfs_dir[fdx][fdy] );
			prefs[ bfs_dir[fdx][fdy] ] +=  W_GoodDirS ;
		    }
		    else {
			if(fdx>ent.x) prefs[dirRight]+=W_GoodDirS ;
			if(fdx<ent.x) prefs[dirLeft]+=W_GoodDirS; 
			if(fdy>ent.y) prefs[dirUp]+=W_GoodDirS ;
			if(fdy<ent.y) prefs[dirDown]+=W_GoodDirS; 
		    }
		}
	    } else {
//		prefs[last_dir] += last_pref;
		pytal_som_sa = 0;
		
//		prefs[dirUp]=1;
//		prefs[dirLeft]=1;
//		prefs[dirRight]=1;
//		prefs[dirDown]=1;
		if (fdsteps<=0) {
		    fdx = random(atlas_w);
		    fdy = random(atlas_h);
		    fdsteps = random(MAX_DSTEPS)+MAX_DSTEPS/2;
//		    printf("making dest at %d %d steps %d           \n", fdx, fdy, fdsteps );
		}

		fdsteps--;
//		printf("going for  dest at %d %d steps %d           \n", fdx, fdy, fdsteps );
		if (bfs_dist[fdx][fdy]<=MAX_BFS) {
//		    printf( " bfs_dir : %d         \n", bfs_dir[fdx][fdy] );
		    prefs[ bfs_dir[fdx][fdy] ] +=  W_GoodDirS ;
		}
		else {
		    if(fdx>ent.x) prefs[dirRight]+=W_GoodDirS ;
		    if(fdx<ent.x) prefs[dirLeft]+=W_GoodDirS; 
		    if(fdy>ent.y) prefs[dirUp]+=W_GoodDirS ;
		    if(fdy<ent.y) prefs[dirDown]+=W_GoodDirS; 
		}
	    }

	    // preferujeme nepreskumane
/*	    prefs[dirRight] += ne_r;
	    prefs[dirLeft] += ne_l;
	    prefs[dirUp] += ne_u;
	    prefs[dirDown] += ne_d;
*/	
	} 

    } // nemame cukor

    
    if (DIALNICE) {
	if (ent.x%2==0) prefs[dirUp]=10;
	else prefs[dirDown]=10;
	if (ent.y%2==0) prefs[dirLeft]=10;
	else prefs[dirRight]=10;
    }
    
    // preplnenost v smere
    prefs[dirRight] +=(int)( prefs[dirRight] * fill_f_dir(k_fill_right) );
    prefs[dirLeft]  +=(int)( prefs[dirLeft]  * fill_f_dir(k_fill_right) );
    prefs[dirUp]    +=(int)( prefs[dirUp]    * fill_f_dir(k_fill_right) );
    prefs[dirDown]  +=(int)( prefs[dirDown]  * fill_f_dir(k_fill_right) );

    // netrepeme sa niekam, kde niekto nie je
    if (ID_PLAYER(map.field[MAP_S-1][MAP_S])>0) prefs[dirLeft] /= 5;
    if (ID_PLAYER(map.field[MAP_S+1][MAP_S])>0) prefs[dirRight] /= 5;
    if (ID_PLAYER(map.field[MAP_S][MAP_S-1])>0) prefs[dirDown] /= 5;
    if (ID_PLAYER(map.field[MAP_S][MAP_S+1])>0) prefs[dirUp] /= 5;
    
    // ani sa nesnazme ist do steny
    if (ID_TYPE(map.field[MAP_S-1][MAP_S])==etWall) prefs[dirLeft] = 0;
    if (ID_TYPE(map.field[MAP_S+1][MAP_S])==etWall) prefs[dirRight] = 0;
    if (ID_TYPE(map.field[MAP_S][MAP_S-1])==etWall) prefs[dirDown] = 0;
    if (ID_TYPE(map.field[MAP_S][MAP_S+1])==etWall) prefs[dirUp] = 0;
   
    // z cukru na cukor
    if (ID_SUGAR(map.field[MAP_S][MAP_S])) {
	if (ID_SUGAR(map.field[MAP_S-1][MAP_S])) prefs[dirLeft] = 0;
	if (ID_SUGAR(map.field[MAP_S+1][MAP_S])) prefs[dirRight] = 0;
	if (ID_SUGAR(map.field[MAP_S][MAP_S+1])) prefs[dirUp] = 0;
	if (ID_SUGAR(map.field[MAP_S][MAP_S-1])) prefs[dirDown] = 0;
    }

    // ak narazame
    if (last_x == ent.x && last_y == ent.y) {
	narazame++;
	if (narazame>MAX_NARAZENI) prefs[last_dir] = 1;
    }
    else
	narazame = 0;

    //  JADRO  ale asi blbo rata...
    i = w_random( prefs, 10 );
    
    if (i != last_dir) {
	last_dir = i;
	last_pref = W_LAST_PREF;
    } else {
//	last_pref /= 2;
	last_pref = prefs[i]/2;
    }

    if (SHOW_PREFS) {
	printf (" pref left  %10lld                                          \n", prefs[dirLeft] );
	printf (" pref right %10lld                                          \n", prefs[dirRight] );
	printf (" pref up    %10lld                                          \n", prefs[dirUp] );
	printf (" pref down  %10lld                                          \n", prefs[dirDown] );

	printf( "\n==============\n                                                   \n" );
	printf( "                                                   \n" );
	printf( "                                                   \n" );
	printf( "                                                   \n" );
	printf( "                                                   \n" );
    }
    
//    if (i==dirSend) fprintf( F, "fakt posielame: ( my_id: 0x%08X )  id:0x%08X   message: 0x%08X                         \n", ent.id, out_msg->id, out_msg->msg );
//    fflush(F);
    return i;
}


// vim:sw=4:ts=8:sts=4:nowrap:noet:aw
