#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>

#include "config.h"

// my own data
TEntity base;

int prizeWorker=0;
int prizeFighter=0;
int map_w=0;
int map_h=0;
int pl=0;

int idx=-1, new_idx=-1;
int step=0, text=0, count=0, next=0;
int nplayers=0;

#include "map/intro/intro.h"


// born
//   called when the entity borns
//    ent          -- this entity (id, coordinates, ...)
//    nplayers     -- number of players in a game
//    map_w,map_h  -- coordinates, size of the map
int born(TEntity ent, int _nplayers, int _map_w, int _map_h, int pr_worker, int pr_fighter){
  srand(time(NULL)+ent.x*ent.y);
  base = ent;

  prizeWorker=pr_worker;
  prizeFighter=pr_fighter;
  map_h=_map_h;
  map_w=_map_w;
  nplayers=_nplayers;

  pl=ID_PLAYER(ent.id)-1;

  idx=-1;
  return dirStay;
}

int step_base(TEntity ent, TMap map, TEntityCount cnt, TMessage *out_msg)
{
  step++;

  if ((step%3)==0) {
    return bornWorker;
  }
  
  return bornNone;
}

int step_fighter(TEntity ent, TMap map, TMessage *out_msg)
{
  return dirStay;
}

int Dir(int dx, int dy) {
  if ((dx<0) &&  (dy<0))  if (dx<dy) return dirDown; else return dirLeft;
  if ((dx<0) &&  (dy>=0)) if (-dx<dy) return dirUp; else return dirLeft;
  if ((dx>=0) && (dy<0))  if (dx<-dy) return dirDown; else return dirRight;
  if ((dx>=0) && (dy>=0)) if (dx<dy) return dirUp; else return dirRight;

  return 1+random(4);
}


int step_worker(TEntity ent, TMap map, TMessage *out_msg)
{
  // chod smerom k policku Intro[ID_PLAYER(ent.id)][ID_SEQ(ent.id)]
  step++;

  switch (step) {
     case 1:	 idx = -1;
    	         new_idx = (ID_SEQ(ent.id)-1)*nplayers + pl;
		 count=CNT0;
    	         text=0;
		 next=500;

		 if (new_idx >= count) new_idx=-1;
		 break;
     
     case 500:   idx = new_idx;			// sprav logo KSP
                 break;

     case 1000:  idx = -1; 
                 new_idx = (ID_SEQ(ent.id)-1)*nplayers + pl;
		 count=CNT1;
    	         text=1;
		 next=1500;
		 
		 if (new_idx >= count) new_idx=-1;
                 break;

     case 1500:  idx = new_idx;			// sprav napis "PROBOJ"
                 break;

     case 2000:  idx = -1;
		 new_idx = (ID_SEQ(ent.id)-1)*nplayers + pl;
		 count=CNT2;
		 text=2;
		 next=2500;  
		 
		 if (new_idx >= count) new_idx=-1;
                 break;
		 
     case 2500:  idx = new_idx;			// sprav napis "CUKOR"
                 break;

     case 3000:  idx = -1;
                 break;

  }

  // after the end, let all workers dissapper :)
  if (step>3100) {
    if ((random(100)==0) || (step>4200)) {
      int i=0,j;
      j=7/i;
    }
  }


  // rob nahodne tahy
  if ((idx<0) || (idx>=count)) {
    if ((new_idx<0) || (random(20)==0)) return 1+random(4);

    int scale=(int)sqrt(abs(next-step))*3;
    
    int want_x=Intro[text][new_idx][0] + random(scale*10+5)-scale*5-2;
    int want_y=Intro[text][new_idx][1] + random(scale*10+5)-scale*5-2;
    
    int dx=want_x - ent.x;
    int dy=want_y - ent.y;
    
    return Dir(dx,dy);
  }

  // chod na miesto
  if (random(20)==0) return 1+random(4);
  
  int dx=Intro[text][idx][0] - ent.x;
  int dy=Intro[text][idx][1] - ent.y;

  return Dir(dx,dy);
}

