#ifndef __GUIMODE_H
#define __GUIMODE_H

#include "config.h"
#include <SDL/SDL.h>
#include <Kyra/kyra.h>

#define MAX_SPRITES    GLOBAL_MAP_SIZE*GLOBAL_MAP_SIZE + MAX_PLAYERS*MAX_ENT + 100

extern int default_player_color[MAX_PLAYERS][3];
extern int player_color[MAX_PLAYERS][3];
extern int fastmode;
extern double PLAYER_SCALE;

bool init_SDL(SDL_Surface** screen, KrEngine** engine);
// bool get_map_sprites(KrEngine **engine, KrSprite **background, int map_h, int map_w, char *map_name, KrResourceVault **vaults);
bool get_sprites(KrEngine **_engine, KrSprite **_obj_sprite, KrTextBox **_text, KrResourceVault **_vaults, char *mapname, TGlobalMap *_map);
bool gui_getkey(SDL_Surface **screen, int &dx, int &dy, bool &tab);
// void gui_drawmap(int map_h, int map_w, char **map, int dx, int dy, player* players, int player_cnt, KrEngine **engine, KrSprite **background, KrSprite **obj_sprite, int **objects, int obj_cnt, int count);
// void text_out(player* players, KrTextBox **text, int map_laps);

int create_sprite(int x, int y, int frame, int zdepth);
void delete_sprite(int index);
void delete_all_sprites(void);

#endif /* __GUIMODE_H */
