#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>

#include "config.h"
//#include "player1-functions.h"

// my own data
TEntity base;

typedef struct{
	int sugar,unit,used;
}mapP;

struct point{
	int x,y,k;
};

struct sugList{
	int x,y,k;
	sugList *n;
}sList;

point mybase;
mapP mymap[GLOBAL_MAP_SIZE][GLOBAL_MAP_SIZE];
point fronta[GLOBAL_MAP_SIZE*GLOBAL_MAP_SIZE];

extern char *PlayerName;
int mapw,maph,playersn,prizeWorker=0,prizeFighter=0,m_size=MAP_SIZE/2;
int state,state2,sugN,count;
point dest;
#define noWay 0
#define toSug 1
#define toBase 2

#define maxWorkers 11
#define maxAllWorkers 40
#define sugRand 7
#define maxFighters 70
#define randMove 20
#define maxCount 60   //mohlo by byt parne

void getBasePos(TEntity ent,TMap map,point *base);
void updateMap(TEntity ent,TMap map);
int search(int x2,int y2,int x1,int y1);
int localMove(TEntity ent,int pos);
void changeSugar(int x,int y,int amount);
void moveSugar(int x, int y);
void logMap(int x,int y);
int abs(int x);

// born
//   called when the entity borns
//    ent          -- this entity (id, coordinates, ...)
//    nplayers     -- number of players in a game
//    map_w,map_h  -- coordinates, size of the map

int born(TEntity ent, int nplayers, int map_w, int map_h, int pr_worker, int pr_fighter){
int i,j;
  sprintf(PlayerName,"SugarFree;");
  srand(time(NULL)+ent.x*ent.y);
  base = ent;
	playersn=nplayers;
	mapw=map_w;
	maph=map_h;
  prizeWorker=pr_worker;
  prizeFighter=pr_fighter;
  for(i=0;i<mapw;i++)
			for(j=0;j<maph;j++){ mymap[i][j].sugar=0; mymap[i][j].unit=0;}
  state=-1;
  state2=noWay;
  sugN=0;
  count=0;
  return dirStay;
}


int step_base(TEntity ent, TMap map, TEntityCount cnt, TMessage *out_msg)
{
  int pl=ID_PLAYER(ent.id),i,j,work=0;

  for(i=0;i<MAP_SIZE;i++)
  	for(j=0;j<MAP_SIZE;j++){
		if((ID_TYPE(map.field[i][j])==etWorker)||(ID_TYPE(map.field[i][j])==etFighter))work++;
		if((ID_PLAYER(map.field[i][j])!=pl)&&
		   (ID_PLAYER(map.field[i][j])!=0)&&
		   (prizeWorker*6>prizeFighter))return bornFighter;
	}
  if((work<maxWorkers)&&(cnt.workers<maxAllWorkers))  return bornWorker;
  if((ent.sugar-prizeFighter>prizeWorker*7)&&(maxFighters>cnt.fighters))return bornFighter;
  return bornNone;
}

int step_fighter(TEntity ent, TMap map, TMessage *out_msg)
{
/*  // test mapy: loguj do suboru
  FILE *f = fopen("log_pl1","a");
  fprintf(f,"====================================\n");
  for (int y=0; y<MAP_SIZE; y++) {
   for (int x=0; x<MAP_SIZE; x++) {
     int et = ID_TYPE(map.field[x][y]);
     int pl = ID_PLAYER(map.field[x][y]);
     if (et==etEmpty) fprintf(f,".. "); else fprintf(f,"%d%d ",et,pl);
   }
   fprintf(f,"\n");
  }
  fclose(f);
*/
	int i,j,dx=0,dy=0,bosx,bosy;
	if(state==-1)getBasePos(ent,map,&mybase);
	state=1;
	for(i=0;i<MAP_SIZE;i++)
		for(j=0;j<MAP_SIZE;j++){
			if((ID_PLAYER(map.field[i][j])!=ID_PLAYER(ent.id))&&(ID_PLAYER(map.field[i][j])!=0)&&
				(ID_PLAYER(map.field[i][j])!=etBase)){
				dx=i-m_size;
				dy=j-m_size;
			}else if((ID_TYPE(map.field[i][j])==etFighter)&&(ID_PLAYER(map.field[i][j])==ID_PLAYER(ent.id))&&
				(ID_SEQ(map.field[i][j])<ID_SEQ(ent.id))){
				bosx=i-m_size;
				bosy=j-m_size;
				state=0;
			}
		}
	if((dx!=0)&&(dy!=0)){
		if ((dx<0) &&  (dy<0))  if (dx<dy) return dirDown; else return dirLeft;
	  	if ((dx<0) &&  (dy>=0)) if (-dx<dy) return dirUp; else return dirLeft;
	  	if ((dx>=0) && (dy<0))  if (dx<-dy) return dirDown; else return dirRight;
	  	if ((dx>=0) && (dy>=0)) if (dx<dy) return dirUp; else return dirRight;
	}
	if(state){
		if(count<=0){
			dx=abs(mapw/2-mybase.x);
			dy=abs(maph/2-mybase.y);
			do{
				dest.x=mapw/2+(2*random(2)-1)*dx;
				dest.y=maph/2+(2*random(2)-1)*dy;
			}while((abs(dest.y-mybase.x)<4)&&(abs(dest.y-mybase.y)<4));
			count=maxCount;
		}else{
			if((ent.x==dest.x)&&(ent.y==dest.y)){
				count=0;
				return random(4)+1;
			}
			if(random(randMove))return random(4)+1;
			dx=dest.x-ent.x;
			dy=dest.y-ent.y;
			if ((dx<0) &&  (dy<0))  if (dx<dy) return dirDown; else return dirLeft;
	  		if ((dx<0) &&  (dy>=0)) if (-dx<dy) return dirUp; else return dirLeft;
	  		if ((dx>=0) && (dy<0))  if (dx<-dy) return dirDown; else return dirRight;
	  		if ((dx>=0) && (dy>=0)) if (dx<dy) return dirUp; else return dirRight;
		}
	}else {
		if((abs(bosx)<=1)&&(abs(bosy)<=1))return random(5);
		//if(random(randMove))return random(4)+1;
		if ((bosx<0) &&  (bosy<0))  if (bosx<bosy) return dirDown; else return dirLeft;
	  	if ((bosx<0) &&  (bosy>=0)) if (-bosx<bosy) return dirUp; else return dirLeft;
	  	if ((bosx>=0) && (bosy<0))  if (bosx<-bosy) return dirDown; else return dirRight;
	  	if ((bosx>=0) && (bosy>=0)) if (bosx<bosy) return dirUp; else return dirRight;
	}
}

int step_worker(TEntity ent, TMap map, TMessage *out_msg)
{
  int dx,dy,ret,i,j,sug=0,work=0,dir[5];
  sugList *tmp;
  	updateMap(ent,map);
  	if(state==-1){
		state=0;
		getBasePos(ent,map,&mybase);
		if((ent.x<mybase.x)&&(ent.y>=mybase.y)){
			for(i=mybase.x-m_size;i<mybase.x;i++)
				for(j=mybase.y+m_size;j>=mybase.y;j--){
					if(mymap[i][j].sugar>0)sug++;
					if(mymap[i][j].unit==etWorker)work=1;
				}
			if((sug>0)&&(!work))state=1;
		}else if((ent.x>=mybase.x)&&(ent.y>mybase.y)){
			for(i=mybase.x;i<=mybase.x+m_size;i++)
				for(j=mybase.y+m_size;j>mybase.y;j--){
					if(mymap[i][j].sugar>0)sug++;
					if(mymap[i][j].unit==etWorker)work=1;
				}
			if((sug>0)&&(!work))state=2;
		}else if((ent.x>mybase.x)&&(ent.y<=mybase.y)){
			for(i=mybase.x+1;i<=mybase.x+m_size;i++)
				for(j=mybase.y;j>=mybase.y-m_size;j--){
					if(mymap[i][j].sugar>0)sug++;
					if(mymap[i][j].unit==etWorker)work=1;
				}
			if((sug>0)&&(!work))state=3;
		}else if((ent.x<=mybase.x)&&(ent.y<mybase.y)){
			for(i=mybase.x-m_size;i<=mybase.x;i++)
				for(j=mybase.y+1;j>=mybase.y-m_size;j--){
					if(mymap[i][j].sugar>0)sug++;
					if(mymap[i][j].unit==etWorker)work=1;
				}
			if((sug>0)&&(!work))state=4;
		}
		for (i=0; i<MAP_SIZE;i++)
		 for (j=0; j<MAP_SIZE; j++)
		  if  (ID_TYPE(map.field[i][j])==etWall) state=0;

	}
	if(state>0){
		ret=localMove(ent,state);
		if(ret==-1){
			state=0;
			state2=noWay;
		}else return ret;
	}
	if(state2==noWay){
		if(ent.sugar){
			if(search(ent.x,ent.y,mybase.x,mybase.y))state2=toBase;
			else return random(4)+1;
		}else if(sugN==0){
			return random(4)+1;
		}else{
			sug=sugN-1;
			if(sug>sugRand)sug=sugRand;
			sug=random(sug);
			tmp=sList.n;
			while(sug>0){
				tmp=tmp->n;
				sug--;
			}
			dest.x=tmp->x;
			dest.y=tmp->y;
			state2=toSug;
			if(search(ent.x,ent.y,dest.x,dest.y))	state2=toSug;
			else {
				moveSugar(dest.x,dest.y);
				return random(4)+1;
				//return dirDown;
			}
		}
	}
	if((state2==toSug)&&(ent.sugar)){
		if(search(ent.x,ent.y,mybase.x,mybase.y))state2=toBase;
		else return random(4)+1;
	}

	if((state2==toBase)&&(!ent.sugar))state2=noWay;

	if((state2==toSug)&&(ent.x==dest.x)&&(ent.y=dest.y))state2=noWay;
	if(state2!=noWay){
		j=0;
		dir[0]=dirLeft;
		if (mymap[ent.x][ent.y].used==mymap[ent.x+1][ent.y].used+1){
		    if(mymap[ent.x+1][ent.y].unit==etEmpty){	dir[j]=dirRight; j++;}
		    else if(mymap[ent.x+1][ent.y].unit==etWall)state2=noWay;
		    else {dir[j]=dirDown; j++;}
		}

		if (mymap[ent.x][ent.y].used==mymap[ent.x-1][ent.y].used+1){
		    if(mymap[ent.x-1][ent.y].unit==etEmpty){dir[j]=dirLeft;j++;}
		    else if(mymap[ent.x-1][ent.y].unit==etWall)state2=noWay;
		    else {dir[j]=dirUp; j++;}
		}

		if (mymap[ent.x][ent.y].used==mymap[ent.x][ent.y+1].used+1){
			if(mymap[ent.x][ent.y+1].unit==etEmpty){dir[j]=dirUp;j++;}
			else if(mymap[ent.x][ent.y+1].unit==etWall)state2=noWay;
		    	else {dir[j]=dirRight; j++;}
		}

		if (mymap[ent.x][ent.y].used==mymap[ent.x][ent.y-1].used+1){
		    if(mymap[ent.x][ent.y-1].unit==etEmpty){dir[j]=dirDown;j++;}
		    else if(mymap[ent.x][ent.y-1].unit==etWall)state2=noWay;
		    else {dir[j]=dirLeft; j++;}
		}

		if (j==0) {state2=noWay; return random(4)+1; }
		return dir[random(j)];
	}
	return dirDown;
	/*if(ent.sugar){
		  		int dx=ent.x-mybase.x;
		  		int dy=ent.y-mybase.y;
	  			if ((dx>0) &&  (dy>0))  if (dx<dy) return dirDown; else return dirLeft;
	  			if ((dx>0) &&  (dy<=0)) if (dx<-dy) return dirUp; else return dirLeft;
	  			if ((dx<=0) && (dy>0))  if (-dx<dy) return dirDown; else return dirRight;
	  			if ((dx<=0) && (dy<=0)) if (-dx<-dy) return dirUp; else return dirRight;
	}*/
	for (int j=0; j<MAP_SIZE; j++)
  	for (int i=0; i<MAP_SIZE; i++) {
    	if ( (ID_TYPE(map.field[i][j]) == etBase)  &&
      	(ID_PLAYER(map.field[i][j]) == ID_PLAYER(ent.id)) ) {
//	printf("==================================\n");
//	printf("== SENDING MESSAGE TO BASE !!!  ==\n");
//	printf("== id=0x%08X",ent.id);
//	printf("==================================\n");
/*				basex=i-MAP_SIZE/2+ent.x;
				basey=j-MAP_SIZE/2+ent.y;*/
/*				log=fopen("log","a");
				fprintf(log,"%d %d \n",basex,basey);
				fclose(log);*/
				if (ent.sugar) {
	  // chod smerom k zakladni odovzdat cukor
		  		int dx=i-MAP_SIZE/2;
		  		int dy=j-MAP_SIZE/2;
//	printf("==================================\n");
//	printf("== HEADING HOME !!!             ==\n");
//	printf("== id=0x%08X                ==\n",ent.id);
//	printf("==================================\n");
	  			if ((dx<0) &&  (dy<0))  if (dx<dy) return dirDown; else return dirLeft;
	  			if ((dx<0) &&  (dy>=0)) if (-dx<dy) return dirUp; else return dirLeft;
	  			if ((dx>=0) && (dy<0))  if (dx<-dy) return dirDown; else return dirRight;
	  			if ((dx>=0) && (dy>=0)) if (dx<dy) return dirUp; else return dirRight;
				}/* else if (random(100)==47) {		// sending message takes one move - don't do it too often ;)
	    		out_msg->id  = map.field[i][j];
 	    		out_msg->msg = 47;
	    		return dirSend;
	  		}*/
			}else if((ID_SUGAR(map.field[i][j])>0)&&(!ent.sugar)){
		  		int dx=i-MAP_SIZE/2;
		  		int dy=j-MAP_SIZE/2;
	  			if ((dx<0) &&  (dy<0))  if (dx<dy) return dirDown; else return dirLeft;
	  			if ((dx<0) &&  (dy>=0)) if (-dx<dy) return dirUp; else return dirLeft;
	  			if ((dx>=0) && (dy<0))  if (dx<-dy) return dirDown; else return dirRight;
	  			if ((dx>=0) && (dy>=0)) if (dx<dy) return dirUp; else return dirRight;
			}
  	}

  return  random(5);
}

int localMove(TEntity ent,int pos){
int dx,dy,i,j;
point sug;
sug.x=-1;
sug.y=-1;
	switch(pos){
	case 1:
		if(ent.sugar){
			if((ent.x==mybase.x-1)&&(random(20)!=0))return dirDown;
			else if(ent.x==mybase.x-1)return dirLeft;
			if((ent.y==mybase.y)&&(random(20)!=0))return dirRight;
			else if(ent.y==mybase.y)return dirUp;
			if(random(2))return dirRight;
			else return dirDown;
		}else{
			for(i=mybase.x-1;(i>=mybase.x-m_size)&&(sug.x==-1);i--)
				for(j=mybase.y;(j<=mybase.y+m_size)&&(sug.x==-1);j++)
					if(mymap[i][j].sugar>0){
						sug.x=i;
						sug.y=j;
					}
			if(sug.x==-1)return -1;
		}
		break;
	case 2:
		if(ent.sugar){
			if((ent.x==mybase.x)&&(random(20)!=0))return dirDown;
			else if(ent.x==mybase.x)return dirRight;
			if((ent.y==mybase.y+1)&&(random(20)!=0))return dirLeft;
			else if(ent.y==mybase.y+1)return dirUp;
			if(random(2))return dirLeft;
			else return dirDown;
		}else{
			for(i=mybase.x;(i<=mybase.x+m_size)&&(sug.x==-1);i++)
				for(j=mybase.y+1;(j<=mybase.y+m_size)&&(sug.x==-1);j++)
					if(mymap[i][j].sugar>0){
						sug.x=i;
						sug.y=j;
					}
			if(sug.x==-1)return -1;
		}
		break;
	case 3:
		if(ent.sugar){
			if((ent.x==mybase.x+1)&&(random(20)!=0))return dirUp;
			else if(ent.x==mybase.x+1)return dirRight;
			if((ent.y==mybase.y)&&(random(20)!=0))return dirLeft;
			else if(ent.y==mybase.y)return dirDown;
			if(random(2))return dirLeft;
			else return dirUp;
		}else{
			for(i=mybase.x+1;(i<=mybase.x+m_size)&&(sug.x==-1);i++)
				for(j=mybase.y;(j>=mybase.y-m_size)&&(sug.x==-1);j--)
					if(mymap[i][j].sugar>0){
						sug.x=i;
						sug.y=j;
					}
			if(sug.x==-1)return -1;
		}
		break;
	case 4:
		if(ent.sugar){
			if((ent.x==mybase.x)&&(random(20)!=0))return dirUp;
			else if(ent.x==mybase.x)return dirLeft;
			if((ent.y==mybase.y+1)&&(random(20)!=0))return dirLeft;
			else if(ent.y==mybase.y+1)return dirDown;
			if(random(2))return dirRight;
			else return dirUp;
		}else{
			for(i=mybase.x;(i>=mybase.x-m_size)&&(sug.x==-1);i--)
				for(j=mybase.y+1;(j>=mybase.y-m_size)&&(sug.x==-1);j--)
					if(mymap[i][j].sugar>0){
						sug.x=i;
						sug.y=j;
					}
			if(sug.x==-1)return -1;
		}
		break;
	}
	dx=sug.x-ent.x;
	dy=sug.y-ent.y;
	if((dx==0)&&(random(10)!=0)){
		if(dy<0)return dirDown;
		else return dirUp;
	}else if(dx==0){
		if(random(2))return dirRight;
		else return dirLeft;
	}
	if((dy==0)&&(random(10)!=0)){
		if(dx>0)return dirRight;
		else return dirLeft;
	}else if(dx==0){
		if(random(2))return dirUp;
		else return dirDown;
	}
	if(random(2)){
		if(dx>0)return dirRight;
		else return dirLeft;
	}else {
		if(dy<0)return dirDown;
		else return dirUp;
	}
	return random(5);
}

void getBasePos(TEntity ent,TMap map,point *base){
int i,j;
/*FILE *f;
f=fopen("log","w");
fprintf(f,"unity\n");
for(i=0;i<mapw;i++){
	for(j=0;j<maph;j++)
		fprintf(f,"%d ",mymap[i][j].unit);
	fprintf(f,"\n");
}
fprintf(f,"sugar\n");
for(i=0;i<mapw;i++){
	for(j=0;j<maph;j++)
		fprintf(f,"%d ",mymap[i][j].sugar);
	fprintf(f,"\n");
}
fclose(f);*/
for (j=0;j<MAP_SIZE; j++)
 for (i=0; i<MAP_SIZE; i++)
    if ( (ID_TYPE(map.field[i][j]) == etBase)  &&
	(ID_PLAYER(map.field[i][j]) == ID_PLAYER(ent.id)) )
	{
    base->x=ent.x-MAP_SIZE/2+i;
	  base->y=ent.y-MAP_SIZE/2+j;
	};
}

void updateMap(TEntity ent,TMap map){
int i,j;
	for(i=0;i<MAP_SIZE+2;i++)
		for(j=0;j<MAP_SIZE+2;j++)if(mymap[ent.x+i-m_size-1][ent.y+j-m_size-1].unit!=1)
			mymap[ent.x+i-m_size-1][ent.y+j-m_size-1].unit=0;
	for(i=0;i<MAP_SIZE;i++)
		for(j=0;j<MAP_SIZE;j++)if((ent.x-m_size+i>0)&&(ent.x-m_size+i<mapw)&&(ent.y-m_size+j>0)&&(ent.y-m_size+j<maph)){
			if(((mymap[ent.x-m_size+i][ent.y-m_size+j].sugar==0)&&(ID_SUGAR(map.field[i][j])>0))||
				((mymap[ent.x-m_size+i][ent.y-m_size+j].sugar==0)&&(ID_SUGAR(map.field[i][j])>0)))
					changeSugar(ent.x-m_size+i,ent.y-m_size+j,ID_SUGAR(map.field[i][j]));
			mymap[ent.x-m_size+i][ent.y-m_size+j].sugar=ID_SUGAR(map.field[i][j]);
			mymap[ent.x-m_size+i][ent.y-m_size+j].unit=ID_TYPE(map.field[i][j]);
			if((ID_PLAYER(map.field[i][j])!=ID_PLAYER(ent.id))
				&&(ID_PLAYER(map.field[i][j])!=0))mymap[ent.x-m_size+i][ent.y-m_size+j].unit+=16;
		}
	mymap[ent.x][ent.y].unit=0;
}

int search(int x2,int y2,int x1,int y1){   //    m  vymenene suradnice
int i,j,z,c;
	for(i=0;i<mapw;i++)
		for(j=0;j<maph;j++)mymap[i][j].used=0;
	fronta[0].x=x1;
	fronta[0].y=y1;
	mymap[x1][y1].used=1;
	fronta[0].k=-1;
	z=0;
	c=0;
	while(z>=c){
		x1=fronta[c].x;
		y1=fronta[c].y;
		if((x1==x2)&&(y1==y2))break;
		if((mymap[x1-1][y1].unit!=etWall)&&((mymap[x1][y1].sugar==0)||(mymap[x1-1][y1].sugar==0))&&(!mymap[x1-1][y1].used)){
			z++;
			fronta[z].x=x1-1;
			fronta[z].y=y1;
			fronta[z].k=c;
			mymap[x1-1][y1].used=mymap[x1][y1].used+1;
		}
		if((mymap[x1+1][y1].unit!=etWall)&&((mymap[x1][y1].sugar==0)||(mymap[x1+1][y1].sugar==0))&&(!mymap[x1+1][y1].used)){
			z++;
			fronta[z].x=x1+1;
			fronta[z].y=y1;
			fronta[z].k=c;
			mymap[x1+1][y1].used=mymap[x1][y1].used+1;
		}
		if((mymap[x1][y1-1].unit!=etWall)&&((mymap[x1][y1].sugar==0)||(mymap[x1][y1-1].sugar==0))&&(!mymap[x1][y1-1].used)){
			z++;
			fronta[z].x=x1;
			fronta[z].y=y1-1;
			fronta[z].k=c;
			mymap[x1][y1-1].used=mymap[x1][y1].used+1;
		}
		if((mymap[x1][y1+1].unit!=etWall)&&((mymap[x1][y1].sugar==0)||(mymap[x1][y1+1].sugar==0))&&(!mymap[x1][y1+1].used)){
			z++;
			fronta[z].x=x1;
			fronta[z].y=y1+1;
			fronta[z].k=c;
			mymap[x1][y1+1].used=mymap[x1][y1].used+1;
		}
		c++;
	}
	//logMap(x2,y2);
	if((x1!=x2)||(y1!=y2))return 0; //// nenasiel    cestu
	else return 1;   //  nasiel cestu
}

void changeSugar(int x,int y,int amount){
sugList *tmp,*tmp2;
	if(amount==0){
		if(sList.n==NULL)return;
		if((sList.n->x==x)&&(sList.n->y==y)){
			tmp=sList.n;
			sList.n=tmp->n;
		}else{
			tmp2=sList.n;
			while((tmp2->n!=NULL)&&((tmp2->n->x!=x)||(tmp2->n->y!=y)))tmp2=tmp2->n;
			tmp=tmp2->n;
			if(tmp!=NULL)tmp2->n=tmp->n;
		}
		if(tmp!=NULL){
			sugN--;
			delete tmp;
		}
	}else {
		/*if(((x-mybase.x>-m_size)&&(x-mybase.x<m_size))&&
		   ((y-mybase.y>-m_size)&&(y-mybase.y<m_size)))return;*/
		tmp=new sugList;
		sugN++;
		tmp->x=x;
		tmp->y=y;
		tmp->k=amount;
		if((sList.n==NULL)||(sList.n->x+sList.n->y>x+y)){
			tmp->n=sList.n;
			sList.n=tmp;
		}else{
			tmp2=sList.n;
			while((tmp2->n!=NULL)&&(sList.n->x+sList.n->y<x+y))tmp2=tmp2->n;
			tmp->n=tmp2->n;
			tmp2->n=tmp;
		}
	}

}

void moveSugar(int x, int y){
sugList *tmp,*tmp2;
	if(sList.n==NULL)return;
	if((sList.n->x==x)&&(sList.n->y==y)){
		tmp=sList.n;
		sList.n=tmp->n;
	}else{
		tmp2=sList.n;
		while(((tmp2->n->x!=x)||(tmp2->n->y!=y))&&(tmp2->n!=NULL))tmp2=tmp2->n;
		tmp=tmp2->n;
		if(tmp!=NULL)tmp2->n=tmp->n;
	}
	if(tmp==NULL)return;
	if(sList.n==NULL){
		sugN--;
		delete tmp;
	}else {
		tmp2=sList.n;
		while(tmp2->n!=NULL)tmp2=tmp2->n;
		tmp2->n=tmp;
		tmp->n=NULL;
	}
}

void logMap(int x,int y){
FILE *f;
int i,j;

	f=fopen("log","a");
	fprintf(f,"at %d %d :used\n",x,y);
	for(i=0;i<mapw;i++){
		for(j=0;j<maph;j++){
			if(mymap[i][j].unit==etBase)fprintf(f,"x");
			fprintf(f,"%d ",mymap[i][j].used);
		}
		fprintf(f,"\n");
	}/*
	fprintf(f,"unity\n");
	for(i=0;i<mapw;i++){
		for(j=0;j<maph;j++)
			fprintf(f,"%d ",mymap[i][j].unit);
		fprintf(f,"\n");
	}
	fprintf(f,"sugar\n");
	for(i=0;i<mapw;i++){
		for(j=0;j<maph;j++)
			fprintf(f,"%d ",mymap[i][j].sugar);
		fprintf(f,"\n");
	}*/
fclose(f);
}

int abs(int x){
	if(x<0)return -x;
	return x;
}
